/*
 * Copyright: GNU Public License 2 applies
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * OMM
 *               (C) 2000 Pierre Ficheux <pficheux@com1.fr>
 *                        Eric Benard <ebenard@free.fr>
 *
 * last changes :
 *   10.08.00 - first version (eb)
 */



/*
@C : "track        length               begin        copy pre ch\n" "%3d.  %7ld [%02d:%02d.%02d]  %7ld [%02d:%02d.%02d]  %s %s %s"
@T : "TOTAL %7ld [%02d:%02d.%02d]    (audio only)"
@E : error code
@X : end
@P : potition
*/
#ifndef _ripper_h
#define _ripper_h

//#define OMM

/* error codes */
#define UNABLE_OPEN_DISC 0x21
#define NO_READ_AUDIO 0x22
#define UNABLE_OPEN_DRIVE 0x23
#define TRACK_NOT_EXIST 0x24
#define SPAN_PARSE 0x25
#define TRACK_OFFSET_OVERFLOW 0x26
#define DISC_OFFSET_OVERFLOW 0x27
#define NO_ARG 0x28
#define SECTOR_SIZE 0x29
#define OVERLAP_SIZE 0x2A
#define NO_AUDIO_TRACK 0x2B
#define NOT_OPEN_FILE 0x2C
#define WRITE_OUTPUT 0x2D
#define DEV_NOTOPEN 0x2E
#define INV_TRACKNR 0x2F
#define PERM_DENIED 0x30
#define TOC_HEADER 0x31
#define TOC_ENTRY 0x32
#define ACC_SECTOR 0x33
#define READ_ERROR 0x34
#define CANT_READ_DATA 0x35

/* ripping status */
#define ST_NORMAL 0x50
#define ST_OVERLAP 0x51
#define ST_DRIFT 0x52
#define ST_LOSS 0x53
#define ST_DROP 0x54
#define ST_SCSI 0x55
#define ST_SCRATCH 0x56
#define ST_SKIP 0x57
#define ST_ENDSKIP 0x58
#define ST_ENDOK 0x59

#endif /* _ripper_h */

