#ident "$Id$"
#ifndef _cdplayer_h
#define _cdplayer_h

#include <sys/types.h>
#include <dirent.h>

#define STATE_CD	        1

#define DISPLAY_CD_LENGTH	0
#define DISPLAY_TRACK_LENGTH	1
#define DISPLAY_TRACK_TITLE	2
#define DISPLAY_CD_ARTIST       3
#define DISPLAY_CD_TITLE	4
#define DISPLAY_LAST_TYPE	5

#define TRACK_MARKED            0
#define TRACK_UNMARKED          1

#define TRACK_MARK              0
#define TRACK_UNMARK            1
#define TRACK_TOGGLE            2

/* Prototypes */

static void display_no_disc(void);
static void display_no_audio(void);
static int check_for_audio_cd(void);
static void display_zero_time(void);
static void set_hscroll_text(void);
static void display_track_length(void);
static void display_disc_length(void);
static void display_hscroll_text(void);
static void display_track_selection(void);
static void do_stop(void);
static void display_disc_info(struct disc_info *info);
static void select_track(void);
static void *cd_check_process(void *dummy);
static void cd_player_default_handler(void);
static void cd_player_eject_close(void);
static void cd_player_eject(void);
static void cd_player_close(void);
static void cd_player_play(void);
static void cd_player_stop(void);
static void cd_player_pause(void);
static void cd_player_next_track(void);
static void cd_player_previous_track(void);
static void cd_player_quit(void);
static void cd_player_toggle_display(void);
static void cd_player_mark_unmark_track(void);
static void cd_player_mark_unmark_all(void);


#endif /* _cdplayer_h */
