#ident "$Id: debug.c,v 1.3 2000/12/12 10:31:40 pierre Exp $"
/* 
 * OMM debug functions
 */

#include "debug.h"

static FILE *fp_log;

/* Syslog or not syslog ? */
#ifdef USE_SYSLOG
void log_debug (level, fmt, p1, p2, p3, p4, p5, p6, p7)
int level;
char *fmt;
int  p1, p2, p3, p4, p5, p6, p7;
{
    char msg[256];

    if (level & debuglevel) {
      sprintf (msg, fmt, p1, p2, p3, p4, p5, p6, p7);
      syslog (LOG_INFO, msg);
    }
}

void log_err (fmt, p1, p2, p3, p4, p5, p6, p7)
char *fmt;
int  p1, p2, p3, p4, p5, p6, p7;
{
  char buf[256];
  
  if (p1) {
    sprintf (buf, fmt, p1, p2, p3, p4, p5, p6, p7);
    syslog (LOG_ERR, buf);
  }
  else
    syslog (LOG_ERR, fmt);

  exit (1);
}
#else

/* Trace de debug */
void log_debug (level, fmt, p1, p2, p3, p4, p5, p6, p7)
int level;
char *fmt;
int  p1, p2, p3, p4, p5, p6, p7;
{
  time_t now;
  char *t;

  if (level & debuglevel) {
    now = time(0);
    t = ctime(&now);
    *(t+strlen(t)-1) = 0;
    
    fprintf (fp_log, "%s(%d) [%s] ", progname, getpid(), t);
    fprintf (fp_log, fmt, p1, p2, p3, p4, p5, p6, p7);
    fprintf (fp_log, "\n\r");
    fflush (fp_log);
  }
}

/* Erreur */
void log_err (fmt, p1, p2, p3, p4, p5, p6, p7)
char *fmt;
int  p1, p2, p3, p4, p5, p6, p7;
{
  time_t now;
  char *t;

  now = time(0);
  t = ctime(&now);
  *(t+strlen(t)-1) = 0;
  
  fprintf (fp_log, "%s(%d) [%s]: ERROR: ", progname, getpid(), t);
  fprintf (fp_log, fmt, p1, p2, p3, p4, p5, p6, p7);
  fprintf (fp_log, "\n\r");
  fflush (fp_log);
}

#endif /* USE_SYSLOG */

void init_debug ()
{
#ifdef USE_SYSLOG
  openlog (progname, LOG_PID | LOG_CONS, LOG_INFO);
#else
  char buf[256];

  if ((fp_log = fopen (DEFAULT_LOG_FILE, "w")) == NULL) {
    if ((fp_log = fopen (TMP_LOG_FILE, "a")) == NULL) {
      perror (buf);
      exit (1);
    }
  }
#endif /* USE_SYSLOG */
}

void close_debug ()
{
#ifndef USE_SYSLOG
  fclose (fp_log);
#endif
}
