#ident "$Id: dpy_curses.c,v 1.1 2000/07/29 12:35:24 pierre Exp $"
/*
 * OMM Display implementation for CURSES library
 */
#include "omm.h"
#include <termios.h>

#include "dpy.h"

static pthread_mutex_t write_mutex;
static struct termios old_stdin_config;
static boolean dumb_use_stdin = FALSE;
/* Init */
void lcd_hw_init (boolean use_stdin)
{
  struct termios term;

  pthread_mutex_init (&write_mutex, NULL);

  /* Always use stdin in dumb mode */
  tcgetattr (0, &term);
  tcgetattr (0, &old_stdin_config);

  term.c_iflag = IGNBRK;
  term.c_lflag = 0;
  term.c_oflag = 0;
  term.c_cc[VMIN] = 1;
  term.c_cc[VTIME] = 0;
  term.c_iflag &= ~(IXON|IXOFF|IXANY);
  term.c_cflag &= ~(PARENB | CSIZE);
  term.c_cflag |= CS8;

  tcsetattr(0, TCSANOW, &term);
}

/* Write string */
void lcd_hw_write (int x, int y, char *s)
{
  pthread_mutex_lock (&write_mutex);
  printf ("%s\r", s);
  pthread_mutex_unlock (&write_mutex);
}

/* Close */
void lcd_hw_close ()
{
    tcsetattr (0, TCSANOW, &old_stdin_config);
}

/* Get input */
int lcd_hw_input ()
{
  char c;

  read (0, &c, 1);

  return c;
}

/* Get win */
unsigned long lcd_hw_get_window ()
{
  return 0L;
}
