#ident "$Id: lcd.h,v 1.2 2000/12/12 10:36:56 pierre Exp pierre $"
#ifndef _lcd_h
#define _lcd_h

#define LCD_WIDTH	20
#define LCD_HEIGHT	4

#define ATTR_NORMAL     0
#define ATTR_BLINK      1

#define LCD_BG_STATE	0
#define LCD_FG_STATE	1

typedef char lcd_attr;

typedef struct _chardef {
  unsigned short code;
  lcd_attr attr;
} chardef;

/* Prototypes */
void lcd_dump_screen(void);
void lcd_bg_screen(void);
void lcd_fg_screen(void);
void lcd_save_area (int x1, int y1, int x2, int y2);
void lcd_restore_area (int x1, int y1, int x2, int y2);
void lcd_init(boolean);
void lcd_close(void);
int lcd_input(void);
void lcd_write(int x, int y, char *s, lcd_attr attr);
void lcd_write_center(int y, char *s, lcd_attr attr);
void lcd_clear(int x1, int y1, int x2, int y2);
void lcd_clear_screen(void);
void lcd_clear_line(int y);
void lcd_init_hscroll (void);
void lcd_write_hscroll (int x, int y, char *s);
void lcd_move (int x, int y);
void lcd_addch (int c, lcd_attr attr);
void lcd_addstr (char *s, lcd_attr attr);
unsigned long lcd_get_window ();

#endif /* _lcd_h */
