#ident "$Id: omm.h,v 1.3 2000/12/12 10:37:44 pierre Exp pierre $"
#ifndef _omm_h
#define _omm_h

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <errno.h>
#include <cdaudio.h>
#include <pthread.h>
#include <termios.h>

#include "omm_api.h"

#include "lcd.h"
#include "list.h"
#include "dpy.h"
#include "misc.h"
#include "debug.h"
#include "fifo.h"

extern char *basename();

#ifndef TRUE
#define TRUE			1
#endif

#ifndef FALSE
#define FALSE			0
#endif

#define OMM_DEFAULT_EVENT	0

#define OMM_ANY_STATE		0
#define OMM_STATE_INIT          0
#define OMM_STATE_INPUT         -1

#define MAX_OMM_INPUT           256

#define CD_DEV			"/dev/cdrom"


/*
 * Directories
 */

/* Base OMM directory */
#define DEFAULT_OMMDIR		"/usr/local/omm"

/* Binarie subdir */
#define BIN_DIR                 "bin"

/* MP3 subdir */
#define MP3_DIR                 "mp3"

/* Playlists subdir */
#define PLAYLISTS_DIR           "playlists"

/* Spool subdir */ 
#define SPOOL_DIR               "spool"

/* Extract subsubdir */ 
#define EXTRACT_DIR             "extract"

/* .disc_info file */
#define DISC_INFO_FILE          ".disc_info"

/*
 * Prefix + suffixes
 */

#define DEFAULT_PREFIX          "default"

/*
 * Suffixes
 */

/* WAV suffix */
#define WAV_SUFFIX              "wav"

/* MP3 suffix */
#define MP3_SUFFIX              "mp3"

/* Playlist suffix */
#define PLAYLIST_SUFFIX         "m3u"

/* Metalist (list of playlists) suffix */
#define METALIST_SUFFIX         "lst"

/* Track suffix */
#define TRACK_SUFFIX            "trk"

#include "global.h"

#endif /* _omm_h */
