#ident "$Id: manager.h,v 1.1 2000/12/12 10:43:52 pierre Exp pierre $"
#ifndef _manager_h
#define _manager_h

#include <signal.h>
#include <fcntl.h>
#include <sys/param.h>



/* States */
#define MANAGER_STATE_CD	1        /* CD player */
#define MANAGER_STATE_MP3	2        /* MP3 player */
#define MANAGER_STATE_ENC	3        /* Extract/Encode (ripper) */ 
#define MANAGER_STATE_FILESEL	4        /* File selector */
#define MANAGER_STATE_NAPSTER	5        /* Napster */

/* Prototypes */
static void manager_quit(void);
static void manager_void(void);
static void manager_execute(char *);
static void manager_default_handler(void);
static void manager_start_cdplayer(void);
static void manager_start_encoder(void);
static void manager_start_mp3player(void);
static void manager_restart_mp3player(void);
static void manager_start_fileselector(void);
static void manager_close_fileselector(void);
static void manager_quit_fileselector(void);
static void manager_toggle_playlist_mode(void);
static void manager_start_enc_editor(void);
static void manager_start_napster(void);
static void manager_quit_napster(void);

#endif /* _manager_h */
