#ident "$Id: mp3player.h,v 1.4 2000/12/12 10:30:37 pierre Exp pierre $"
#ifndef _mp3player_h
#define _mp3player_h

#include <sys/param.h>
#include <signal.h>

#define MPG123  		"/usr/local/omm/bin/mpg123o"
#define PLAYER_IN		pipe_in[0]
#define PLAYER_OUT		pipe_out[1]



#define MODE_STOPPED 		0
#define MODE_PLAYING 		1
#define MODE_PAUSED 		2
#define MODE_LOADED 		3

#define MAXTRACKS		100

#define DISPLAY_TRACK_LENGTH	0
#define DISPLAY_TOTAL_LENGTH	1
#define DISPLAY_FILENAME        2
#define DISPLAY_LAST_TYPE_NOID3 3
#define DISPLAY_TITLE	        3
#define DISPLAY_ARTIST          4
#define DISPLAY_ALBUM	        5
#define DISPLAY_YEAR	        6
#define DISPLAY_COMMENT         7
#define DISPLAY_GENRE           8
#define DISPLAY_LAST_TYPE	9

struct id3tag {
  char title[30];
  char artist[30];
  char album[30];
  char year[4];
  char comment[30];
  char genre[30];
};

typedef struct _mp3_track {
  char type[4];
  int layer;
  int frequency;
  char mode[4];
  int bitrate;
  float sectotal;
  struct id3tag *tag;
  char *pathname;
  char *filename;
} mp3_track;

/* Prototypes */
static void do_stop(void);
static void write_mpg123_cmd(char *s, int size);
static void read_mpg123_status(char *s, int size);
static void *display_time_process(void *dummy);
static void mp3_player_play(void);
static void mp3_player_stop(void);
static void mp3_player_pause(void);
static void mp3_player_quit(void);
static void mp3_player_next_track(void);
static void mp3_player_previous_track(void);
static void display_track_length(void);
static void display_total_length(void);
static void mp3_player_toggle_display(void);
static void mp3_player_reload(void);
static void mp3_player_default_handler(void);

#endif /* _mp3player_h */
