#ident "$Id$"
#ifndef _napster_h
#define _napster_h

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/param.h>
#include <sys/types.h>
#include <signal.h>
#include <dirent.h>
#include <sys/ioctl.h>
#include <linux/cdrom.h>

#define NAP_IN	        pipe_in[0]
#define NAP_OUT	        pipe_out[1]

/* External Napster client */
#define NAP  		"/usr/local/omm/bin/napo"

/* I/O fifo with external Napster (napo) */
#define NAPIO           "/tmp/napio"

/* States */
#define STATE_CONNECTED      1         /* Client is connected */
#define STATE_RESULTS        2         /* Display results (list of songs) */
#define STATE_DOWNLOAD       3         /* Display downloads */

/* Prototypes */
static void napster_quit(void);
static void napster_search(void);
static void napster_next_song(void);
static void napster_prev_song(void);
static void napster_download(void);
static void napster_next_download(void);
static void napster_prev_download(void);
static void napster_update(void);
static void napster_results(void);
static void napster_delete(void);
static void napster_default_handler(void);

#endif /* _napster_h */
