#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/cursorfont.h>
#include "omm.h"

#define MAIN_WIDTH          900
#define MAIN_HEIGHT         200
#define OFF_WIDTH           50
#define OFF_HEIGHT          50
#define CD_WIDTH            430
#define CD_HEIGHT           70

Cursor hand;
GC	gc;
Display	*display;
int	screen;
Window	win, womm, woff, wcd, root;
unsigned long white_pixel, black_pixel;
static int font_height, font_width, font_descent;
XFontStruct *xfs;
XColor gray1, gray2, green2;

/*
 * fonction associee a l'evenement EXPOSE 
 */

void expose ()
{
  XSetForeground (display, gc, white_pixel);
  XDrawString (display, woff, gc, 8, 30, "OFF", 3);
  //  XDrawString (display, win, gc, 700, 140, "Open Music Machine", 18);

  //  system ("/usr/local/omm/bin/manager_x11");
}

/*
 * programme principal
 */

main(ac, av)
int ac;
char **av;
{
    char *dpyn = NULL, buf[256];
    int h, w;

    /* selection du display en ligne */
    if (ac == 3) {
	if (strcmp (&av[1][1], "display") == 0) {
	    dpyn = av[2];
	}
	else {
	    fprintf (stderr, "Usage: %s [-display display_name]\n", av[0]);
	    exit (1);
	}
    }

    if ((display = XOpenDisplay (dpyn)) == NULL) {
	fprintf (stderr, "Can't open Display\n");
	exit (1);
    }

    gc = DefaultGC (display, screen);
    screen = DefaultScreen (display);
    root = RootWindow (display, screen);

    /* Set font */
    xfs = XLoadQueryFont (display, "10x20");
    if (!xfs) {
      fprintf (stderr, "Can't load font, exiting.\n");
      exit (1);
    }

    font_width = xfs->max_bounds.width;
    font_height = xfs->ascent + xfs->descent;
    font_descent = xfs->descent;
    XSetFont (display, gc, xfs->fid);

    hand = XCreateFontCursor (display, XC_hand2);

    gray1.red = 0x88 << 8;
    gray1.green = 0x88 << 8;
    gray1.blue = 0x88 << 8;
    XAllocColor (display, DefaultColormap (display, screen), &gray1);

    gray2.red = 0x50 << 8;
    gray2.green = 0x50 << 8;
    gray2.blue = 0x50 << 8;
    XAllocColor (display, DefaultColormap (display, screen), &gray2);

    green2.red = 0x90 << 8;
    green2.green = 0xd8 << 8;
    green2.blue = 0;
    XAllocColor (display, DefaultColormap (display, screen), &green2);

    white_pixel = WhitePixel (display, screen);
    black_pixel = BlackPixel (display, screen);

    win = XCreateSimpleWindow (display, root, 0, 0, MAIN_WIDTH, MAIN_HEIGHT, 2, black_pixel, black_pixel);

    h = LCD_HEIGHT * (font_height + 2);
    w = LCD_WIDTH * (font_width + 2);
    womm = XCreateSimpleWindow (display, win, 50, (MAIN_HEIGHT-h)/2 - 2, w, h, 2, gray1.pixel, green2.pixel);
    wcd = XCreateSimpleWindow (display, win, 370, (MAIN_HEIGHT-CD_HEIGHT)/2 - 2, CD_WIDTH, CD_HEIGHT, 2, black_pixel, white_pixel);
    woff = XCreateSimpleWindow (display, win, MAIN_WIDTH-OFF_WIDTH-10, (MAIN_HEIGHT-OFF_HEIGHT)/2 - 2, OFF_WIDTH, OFF_HEIGHT, 2, gray2.pixel, gray1.pixel);

    sprintf (buf, "OMMWIN=%x", (int)womm);
    putenv (buf);

    XSelectInput (display, win, ExposureMask);
    XSelectInput (display, woff, ExposureMask|EnterWindowMask|LeaveWindowMask|ButtonPressMask);

    XStoreName (display, win, "xomm");
    XMapWindow (display, win);
    XMapWindow (display, womm);
    XMapWindow (display, woff);
    XMapWindow (display, wcd);

    for (;;) {
	XEvent ev;
	char c;

	XNextEvent (display, &ev);

	switch (ev.type) {
	  case Expose :
	    expose ();
	    break;

	  case EnterNotify :
	    if (ev.xcrossing.window == woff)
	      XDefineCursor (display, woff, hand);
	    break;

	  case LeaveNotify :
	    if (ev.xcrossing.window == woff)
	      XUndefineCursor (display, woff);
	    break;

	  case ButtonPress :
	    if (ev.xcrossing.window == woff)
	      exit (0);
	    break;

	default :
	  break;
	}
    }
}


