#!/usr/bin/perl -w
# $Id: xir.pl,v 1.1 2000/12/12 10:55:12 pierre Exp pierre $
#
# IR control simulator
#
# Pierre Ficheux (pierre@alienor.fr)
#
# 
require Tk;
use Tk;
use Tk::Balloon;

# Send a char to the fifo
sub send_cmd($) {
    syswrite (OUT, $_[0], 1);
}

# Send a kbd char
sub send_kbd {
    $key = substr($_[0], 0, 1);
    if ( $old_key == $key ) {
	$key_index++;
	if ( $key_index == length($_[0]) ) {
	    $key_index = 0;
	}
    }
    else {
	$key_index = 0;
    }

    my $val = substr($_[0], $key_index, 1);
    $old_key = $key;

    send_cmd ($val);
}

# Open fifo
$key = 0;
$key_index = 0;
$old_key = 0;

use Fcntl qw( O_RDWR );
sysopen(OUT, "/tmp/irmanager", O_RDWR) || die "Can't open /tmp/irmanager!";

# Main win
my $main=MainWindow->new();
$main->minsize(qw(250 250));
$main->title("IR control");

# Bitmap creation
$main->Bitmap ('up',
-file => 'bitmaps/up.xbm',
-maskfile => 'bitmaps/up.xbm'
);

$main->Bitmap ('down',
-file => 'bitmaps/down.xbm',
-maskfile => 'bitmaps/down.xbm'
);

$main->Bitmap ('left',
-file => 'bitmaps/left.xbm',
-maskfile => 'bitmaps/left.xbm'
);

$main->Bitmap ('right',
-file => 'bitmaps/right.xbm',
-maskfile => 'bitmaps/right.xbm'
);

$main->Bitmap ('pause',
-file => 'bitmaps/pause.xbm',
-maskfile => 'bitmaps/pause.xbm'
);

$main->Bitmap ('pgdown',
-file => 'bitmaps/pgdown.xbm',
-maskfile => 'bitmaps/pgdown.xbm'
);

$main->Bitmap ('pgup',
-file => 'bitmaps/pgup.xbm',
-maskfile => 'bitmaps/pgup.xbm'
);

$main->Bitmap ('play',
-file => 'bitmaps/play.xbm',
-maskfile => 'bitmaps/play.xbm'
);

$main->Bitmap ('rewind',
-file => 'bitmaps/rewind.xbm',
-maskfile => 'bitmaps/rewind.xbm'
);

$main->Bitmap ('wind',
-file => 'bitmaps/wind.xbm',
-maskfile => 'bitmaps/wind.xbm'
);

$main->Bitmap ('stop',
-file => 'bitmaps/stop.xbm',
-maskfile => 'bitmaps/stop.xbm'
);

# Frames
my $frame01 = $main->Frame;
$frame01->pack(-pady => 5);

my $frame02 = $main->Frame;
$frame02->pack(-pady => 5);

my $frame03 = $main->Frame;
$frame03->pack(-pady => 5);

my $frame1 = $main->Frame;
$frame1->pack(-pady => 5);

my $frame2 = $main->Frame;
$frame2->pack(-pady => 5);

my $frame21 = $main->Frame;
$frame21->pack(-pady => 5);

my $frame3 = $main->Frame;
$frame3->pack(-pady => 5);

my $frame41 = $main->Frame;
$frame41->pack(-pady => 5);

my $frame42 = $main->Frame;
$frame42->pack(-pady => 5);

my $frame43 = $main->Frame;
$frame43->pack(-pady => 5);

my $frame44 = $main->Frame;
$frame44->pack(-pady => 5);

my $frame4 = $main->Frame;
$frame4->pack(-pady => 5);

# Buttons
my $up_btn = $frame01->Button(
-image => 'up',
-command => sub {send_cmd 'k'},
)->pack(-side => 'left', -padx => 1);

my $pgup_btn = $frame01->Button(
-image => 'pgup',
-command => sub {send_cmd "\x15"},
)->pack(-side => 'left', -padx => 1);

my $left_btn = $frame02->Button(
-image => 'left',
-command => sub {send_cmd 'a'},
)->pack(-side => 'left', -padx => 1);

my $val_btn = $frame02->Button(
-text => 'Validate',
-command => sub {send_cmd "\n"},
)->pack(-side => 'left', -padx => 1);

my $sel_btn = $frame02->Button(
-text => 'Select',
-command => sub {send_cmd " "},
)->pack(-side => 'left', -padx => 1);

my $quit_btn = $frame02->Button(
-text  => 'Quit', 
-command => sub {send_cmd "\x1b"},
)->pack(-side => 'left', -padx => 1);

my $del_btn = $frame02->Button(
-text  => 'Del', 
-command => sub {send_cmd 'D'},
)->pack(-side => 'left', -padx => 1);


my $right_btn = $frame02->Button(
-image => 'right',
-command => sub {send_cmd 'n'},
)->pack(-side => 'left', -padx => 1);

my $down_btn = $frame03->Button(
-image => 'down',
-command => sub {send_cmd 'j'},
)->pack(-side => 'left', -padx => 1);

my $pgdown_btn = $frame03->Button(
-image => 'pgdown',
-command => sub {send_cmd "\x16"},
)->pack(-side => 'left', -padx => 1);

my $rewind_btn = $frame1->Button(
-image => 'rewind',
-command => sub {send_cmd '-'},
)->pack(-side => 'left', -padx => 1);

my $pause_btn = $frame1->Button(
-image => 'pause',
-command => sub {send_cmd 'h'},
)->pack(-side => 'left', -padx => 1);

my $stop_btn = $frame1->Button(
-image => 'stop',
-command => sub {send_cmd 's'},
)->pack(-side => 'left', -padx => 1);

my $play_btn = $frame1->Button(
-image => 'play',
-command => sub {send_cmd 'p'},
)->pack(-side => 'left', -padx => 1);

my $wind_btn = $frame1->Button(
-image => 'wind',
-command => sub {send_cmd '+'},
)->pack(-side => 'left', -padx => 1);

my $open_close_btn = $frame2->Button(
-text  => 'Open/Close', 
-command => sub {send_cmd 'e'},
)->pack(-side => 'left', -padx => 1);

my $display_btn = $frame2->Button(
-text  => 'Display', 
-command => sub {send_cmd 't'},
)->pack(-side => 'left', -padx => 1);

my $mode_btn = $frame2->Button(
-text  => 'Dir/List', 
-command => sub {send_cmd 'M'},
)->pack(-side => 'left', -padx => 1);

my $mark_btn = $frame2->Button(
-text  => 'Mark/Unmark', 
-command => sub {send_cmd 'u'},
)->pack(-side => 'left', -padx => 1);

my $search_btn = $frame21->Button(
-text  => 'Search', 
-command => sub {send_cmd 'S'},
)->pack(-side => 'left', -padx => 1);

my $results_btn = $frame21->Button(
-text  => 'Results', 
-command => sub {send_cmd 'r'},
)->pack(-side => 'left', -padx => 1);

my $downloads_btn = $frame21->Button(
-text  => 'Downloads', 
-command => sub {send_cmd 'd'},
)->pack(-side => 'left', -padx => 1);


my $cd_btn = $frame3->Button(
-text  => 'CD', 
-command => sub {send_cmd 'c'},
)->pack(-side => 'left', -padx => 1);

my $mp3_btn = $frame3->Button(
-text  => 'MP3', 
-command => sub {send_cmd 'm'},
)->pack(-side => 'left', -padx => 1);

my $enc_btn = $frame3->Button(
-text  => 'ENC', 
-command => sub {send_cmd 'z'},
)->pack(-side => 'left', -padx => 1);

my $edit_btn = $frame3->Button(
-text  => 'EDIT', 
-command => sub {send_cmd 'e'},
)->pack(-side => 'left', -padx => 1);

my $fsel_btn = $frame3->Button(
-text  => 'FSEL', 
-command => sub {send_cmd 'f'},
)->pack(-side => 'left', -padx => 1);

my $nap_btn = $frame3->Button(
-text  => 'NAP', 
-command => sub {send_cmd 'n'},
)->pack(-side => 'left', -padx => 1);

# Clavier
my $one_btn = $frame41->Button(
-text  => '1    ', 
-command => sub {send_cmd '1'},
)->pack(-side => 'left', -padx => 1);

my $two_btn = $frame41->Button(
-text  => '2 abc', 
-command => sub {send_kbd '2ABC'},
)->pack(-side => 'left', -padx => 1);

my $three_btn = $frame41->Button(
-text  => '3 def', 
-command => sub {send_kbd '3DEF'},
)->pack(-side => 'left', -padx => 1);

my $four_btn = $frame42->Button(
-text  => '4 ghi', 
-command => sub {send_kbd '4GHI'},
)->pack(-side => 'left', -padx => 1);

my $five_btn = $frame42->Button(
-text  => '5 jkl', 
-command => sub {send_kbd '5JKL'},
)->pack(-side => 'left', -padx => 1);

my $six_btn = $frame42->Button(
-text  => '6 mno', 
-command => sub {send_kbd '6MNO'},
)->pack(-side => 'left', -padx => 1);

my $seven_btn = $frame43->Button(
-text  => '7 pqrs', 
-command => sub {send_kbd '7PQRS'},
)->pack(-side => 'left', -padx => 1);

my $eight_btn = $frame43->Button(
-text  => '8 tuv', 
-command => sub {send_kbd '8TUV'},
)->pack(-side => 'left', -padx => 1);

my $nine_btn = $frame43->Button(
-text  => '9 wxyz', 
-command => sub {send_kbd '9WXYZ'},
)->pack(-side => 'left', -padx => 1);

my $left1_btn = $frame44->Button(
-text  => ' < ', 
-command => sub {send_cmd "\x02"},
)->pack(-side => 'left', -padx => 1);

my $zero_btn = $frame44->Button(
-text  => '0    ', 
-command => sub {send_cmd '0'},
)->pack(-side => 'left', -padx => 1);


my $right1_btn = $frame44->Button(
-text  => ' > ', 
-command => sub {send_cmd "\x06"},
)->pack(-side => 'left', -padx => 1);


my $off_btn = $frame4->Button(
-text  => 'Off', 
-command => sub {send_cmd 'x'},
)->pack(-side => 'left', -padx => 1);

# Balloon

my $open_close_help = $main->Balloon(-background => 'yellow');
$open_close_help->attach($open_close_btn,
-balloonmsg => "Open/close tray");

my $display_help = $main->Balloon(-background => 'yellow');
$display_help->attach($display_btn,
-balloonmsg => "Toggle display on track");

my $mode_help = $main->Balloon(-background => 'yellow');
$mode_help->attach($mode_btn,
-balloonmsg => "Directory/Playlist mode");

my $cd_help = $main->Balloon(-background => 'yellow');
$cd_help->attach($cd_btn,
-balloonmsg => "Open CD player");

my $mp3_help = $main->Balloon(-background => 'yellow');
$mp3_help->attach($mp3_btn,
-balloonmsg => "Open MP3 player");

my $fsel_help = $main->Balloon(-background => 'yellow');
$fsel_help->attach($fsel_btn,
-balloonmsg => "Open file-selector");




MainLoop();

# This is the end.
