#!/bin/sh

echo MIME-Version: 1.0
echo Content-type: text/html
echo 

. /etc/sysconfig/variables
if [ -r $BASE/$NETWORKCFG ]; then
	. $BASE/$NETWORKCFG
else
        echo "<BODY><H1>Fichier $BASE/$NETWORKCFG inexistant !</H1></BODY>"
fi

# Inits par dfaut
if [ "$HOSTNAME" = "" ]; then
	HOSTNAME=`echo lnx$$ | cut -c1-8`
fi
if [ "$DOMAINNAME" = "" ]; then
	DOMAINNAME="some.where"
fi
if [ "$DEVICE" = "" ]; then
	DEVICE=eth0
fi


case "$DEVICE" in
eth0) S_ETH0=SELECTED;;
*) S_ETH0=SELECTED;;
esac

# Calcul sur adresse IP
get_ip_member ()
{
    if [ "$1" != "" -a "$2" != "" ]; then
	X=`echo $1 | sed -e "s/\./ /g"`
	N=$2
	set $X
	case $N in
	    1) echo $1;;
	    2) echo $2;;
	    3) echo $3;;
	    4) echo $4;;
	    *) ;;
	esac
    fi	
}

cat << EOF

<SCRIPT LANGUAGE="JavaScript"> 

// Calcul de la classe a partir de l'adresse IP
function get_net_class (ip1, ip2, ip3, ip4)
{
    if (!check_value(ip1) || !check_value(ip2) || !check_value(ip3) || !check_value(ip4))
	return 0;

    i1 = ip1.value;
    i2 = ip2.value;
    i3 = ip3.value;
    i4 = ip4.value;

    if (i1 == "" || i2 == "" || i3 == "" || i4 == "")
	return 0;

    // Netmask, Broadcast & Gateway
    // Class A
    if (i1 >= 0 && i1 <= 127)
	return 1;
    // Class B
    else if (i1 >= 128 && i1 <= 191)
	return 2;
    // Class C
    else if (i1 >= 192 && i1 <= 223)
	return 3;
    // D & E Reserved, currently == Class C
    else
	return 4;
}

// Verifie la plage 0/254
function check_value (v)
{
    if (v.value < 0 || v.value > 255) {
	  alert ("Valeur " + v.value + " incorrecte !");
	  v.value = "";

	  return (false);
    }

    return (true);
}

// Mise a jour GW en fonction de l'adresse IP
function update_gw_value (gw1, gw2, gw3, ip1, ip2, ip3, ip4)
{
    if (gw1.value == "" && gw2.value == "" && gw3.value == "")
	return true;

    net_class = get_net_class (ip1, ip2, ip3, ip4);

    if (net_class == 0)
	return false;

    switch (net_class) {
	case 1:
	    gw1.value = ip1.value;
	    break;

        case 2:
	    gw1.value = ip1.value;
	    gw2.value = ip2.value;
	    break;

        default:
	    gw1.value = ip1.value;
	    gw2.value = ip2.value;
	    gw3.value = ip3.value;
	    break;
    }
	
    return true;
}

// Verifie la GW
function check_gw_value(v, i, ip1, ip2, ip3, ip4)
{
    net_class = get_net_class (ip1, ip2, ip3, ip4);
    val = v.value;

    switch (i) {
	case 1:
	    if (val != ip1.value) {
		alert ("Valeur " + val + " incorrecte !");
		v.value = ip1.value;
	    }
	    break;

        case 2:
	    if (net_class >= 2 && val != ip2.value) {
		alert ("Valeur " + val + " incorrecte !");
		v.value = ip2.value;
	    }
	    break;

        default:
	    if (net_class >= 3 && val != ip3.value) {
		alert ("Valeur " + val + " incorrecte !");
		v.value = ip3.value;
	    }
	    break;
    }
	
    return true;
}

// Calcul Netmask + Broadcast en fonction de l'adresse IP
function calcul_network_parameters (ip1, ip2, ip3, ip4, nm1, nm2, nm3, nm4, bd1, bd2, bd3, bd4) 
{
    net_class = get_net_class (ip1, ip2, ip3, ip4);

    if (net_class == 0)
	return false;

    i1 = ip1.value;
    i2 = ip2.value;
    i3 = ip3.value;
    i4 = ip4.value;

    // Netmask, Broadcast & Gateway
    switch (net_class) {
	case 1: // Class A
	    nm1.value = 255;
	    nm2.value = nm3.value = nm4.value = 0;
	    bd1.value = i1;
	    bd2.value = bd3.value = bd4.value = 255;
	    break;

	case 2: // Class B
	    nm1.value = nm2.value = 255;
	    nm3.value = nm4.value = 0;
	    bd1.value = i1;
	    bd2.value = i2;
	    bd3.value = bd4.value = 255;
	    break;

	default: // Class C or +
	    nm1.value = nm2.value = nm3.value = 255;
	    nm4.value = 0;
	    bd1.value = i1;
	    bd2.value = i2;
	    bd3.value = i3;
	    bd4.value = 255;
	    break;
    }

    return (true);
}

</SCRIPT>

<BODY>
<CENTER>
<H1>Configuration rseau</H1>
</CENTER>
<HR>
<P>

<FORM ACTION="set_network.cgi">

<TABLE COLS=2>

<TR>
<TD WIDTH=$MAXWIDTH>Interface:</TD>
<TD>
<SELECT NAME="DEVICE" VALUE="$DEVICE">
<OPTION $S_ETH0>eth0
<OPTION $S_ETH1>eth1
</SELECT>

</TD>
</TR>

<TR>
<TD WIDTH=$MAXWIDTH>Nom de machine:</TD>
<TD><INPUT NAME="HOSTNAME" VALUE="$HOSTNAME" SIZE=8></TD>
</TR>

<TR>
<TD WIDTH=$MAXWIDTH>Nom de domaine:</TD>
<TD><INPUT NAME="DOMAINNAME" VALUE="$DOMAINNAME" SIZE=20></TD>
</TR>

<TR>
<TD WIDTH=$MAXWIDTH>Adresse IP:</TD>

<TD>
<INPUT NAME="IP1" VALUE="`get_ip_member $IPADDR 1`" SIZE=3 OnChange="calcul_network_parameters(this,form.IP2,form.IP3,form.IP4,form.NM1,form.NM2,form.NM3,form.NM4,form.BD1,form.BD2,form.BD3,form.BD4); update_gw_value(form.GW1,form.GW2,form.GW3,this,form.IP2,form.IP3,form.IP4)">.
<INPUT NAME="IP2" VALUE="`get_ip_member $IPADDR 2`" SIZE=3 OnChange="calcul_network_parameters(form.IP1,this,form.IP3,form.IP4,form.NM1,form.NM2,form.NM3,form.NM4,form.BD1,form.BD2,form.BD3,form.BD4); update_gw_value(form.GW1,form.GW2,form.GW3,form.IP1,this,form.IP3,form.IP4)">.
<INPUT NAME="IP3" VALUE="`get_ip_member $IPADDR 3`" SIZE=3 OnChange="calcul_network_parameters(form.IP1,form.IP2,this,form.IP4,form.NM1,form.NM2,form.NM3,form.NM4,form.BD1,form.BD2,form.BD3,form.BD4); update_gw_value(form.GW1,form.GW2,form.GW3,form.IP1,form.IP2,this,form.IP4)">.
<INPUT NAME="IP4" VALUE="`get_ip_member $IPADDR 4`" SIZE=3 OnChange="calcul_network_parameters(form.IP1,form.IP2,form.IP3,this,form.NM1,form.NM2,form.NM3,form.NM4,form.BD1,form.BD2,form.BD3,form.BD4); update_gw_value(form.GW1,form.GW2,form.GW3,form.IP1,form.IP2,form.IP3,this)">
</TD>
</TR>

<TR>
<TD WIDTH=$MAXWIDTH>Passerelle:</TD>
<TD>
<INPUT NAME="GW1" VALUE="`get_ip_member $GATEWAY 1`" SIZE=3 OnChange="update_gw_value(this,form.GW2,form.GW3,form.IP1,form.IP2,form.IP3,form.IP4)">.
<INPUT NAME="GW2" VALUE="`get_ip_member $GATEWAY 2`" SIZE=3 OnChange="update_gw_value(form.GW1,this,form.GW3,form.IP1,form.IP2,form.IP3,form.IP4)">.
<INPUT NAME="GW3" VALUE="`get_ip_member $GATEWAY 3`" SIZE=3 OnChange="update_gw_value(form.GW1,form.GW2,this,form.IP1,form.IP2,form.IP3,form.IP4)">.
<INPUT NAME="GW4" VALUE="`get_ip_member $GATEWAY 4`" SIZE=3 OnChange="check_value(this)">
</TD>
</TR>

<TR>
<TD WIDTH=$MAXWIDTH>Netmask:</TD>
<TD>
<INPUT NAME="NM1" VALUE="`get_ip_member $NETMASK 1`" SIZE=3 OnChange="check_value(this)">.
<INPUT NAME="NM2" VALUE="`get_ip_member $NETMASK 2`" SIZE=3 OnChange="check_value(this)">.
<INPUT NAME="NM3" VALUE="`get_ip_member $NETMASK 3`" SIZE=3 OnChange="check_value(this)">.
<INPUT NAME="NM4" VALUE="`get_ip_member $NETMASK 4`" SIZE=3 OnChange="check_value(this)">
</TD>
</TR>

<TR>
<TD WIDTH=$MAXWIDTH>Broadcast:</TD>
<TD>
<INPUT NAME="BD1" VALUE="`get_ip_member $BROADCAST 1`" SIZE=3 OnChange="check_value(this)">.
<INPUT NAME="BD2" VALUE="`get_ip_member $BROADCAST 2`" SIZE=3 OnChange="check_value(this)">.
<INPUT NAME="BD3" VALUE="`get_ip_member $BROADCAST 3`" SIZE=3 OnChange="check_value(this)">.
<INPUT NAME="BD4" VALUE="`get_ip_member $BROADCAST 4`" SIZE=3 OnChange="check_value(this)">
</TD>
</TR>

<TR>
<TD WIDTH=$MAXWIDTH>Serveur de noms 1:</TD>
<TD>
<INPUT NAME="DNS1_1" VALUE="`get_ip_member $DNS1 1`" SIZE=3 OnChange="check_value(this)">.
<INPUT NAME="DNS1_2" VALUE="`get_ip_member $DNS1 2`" SIZE=3 OnChange="check_value(this)">.
<INPUT NAME="DNS1_3" VALUE="`get_ip_member $DNS1 3`" SIZE=3 OnChange="check_value(this)">.
<INPUT NAME="DNS1_4" VALUE="`get_ip_member $DNS1 4`" SIZE=3 OnChange="check_value(this)">
</TD>
</TR>

<TR>
<TD WIDTH=$MAXWIDTH>Serveur de noms 2:</TD>
<TD>
<INPUT NAME="DNS2_1" VALUE="`get_ip_member $DNS2 1`" SIZE=3 OnChange="check_value(this)">.
<INPUT NAME="DNS2_2" VALUE="`get_ip_member $DNS2 2`" SIZE=3 OnChange="check_value(this)">.
<INPUT NAME="DNS2_3" VALUE="`get_ip_member $DNS2 3`" SIZE=3 OnChange="check_value(this)">.
<INPUT NAME="DNS2_4" VALUE="`get_ip_member $DNS2 4`" SIZE=3 OnChange="check_value(this)">
</TD>
</TR>

</TABLE>

<P>

<INPUT NAME=VALIDER TYPE=submit VALUE="Valider la configuration">
<INPUT NAME=ANNULER TYPE=reset VALUE=Effacer>

</FORM>
</BODY>

EOF
