#!/bin/sh

echo MIME-Version: 1.0
echo Content-type: text/html
echo 

. /etc/sysconfig/variables

if [ -r $BASE/$NETWORKCFG ]; then
	. $BASE/$NETWORKCFG
else
        echo "<BODY><H1>Fichier $BASE/$NETWORKCFG inexistant !</H1></BODY>"
fi


if [ "$QUERY_STRING" != "" ]; then
    QUERY=`echo $QUERY_STRING | sed -e "s/=/='/g" -e "s/&/';/g" -e "s/+/ /g"  -e "s/$/'/"`
    eval $QUERY

get_ip_addr ()
{
	X=
	for i in 1 2 3 4
	do
		if [ "$1" != "" ]; then
			X=${X}${1}
			if [ $i -ne 4 ]; then
				X=${X}"."
			fi
		else
			X=""
			break
		fi
		shift
	done
	echo $X
}

# Analyse des paramtres
if [ "$HOSTNAME" = "" ]; then
	echo "<BODY><H1>Pas de nom de machine !</H1></BODY>"
	exit 0
fi

cat << EOF > $SPOOL/$NETWORKCFG
# Network configuration
HOSTNAME=$HOSTNAME
DOMAINNAME=$DOMAINNAME
DEVICE=$DEVICE
IPADDR=`get_ip_addr ${IP1} ${IP2} ${IP3} ${IP4}`
GATEWAY=`get_ip_addr ${GW1} ${GW2} ${GW3} ${GW4}`
NETMASK=`get_ip_addr ${NM1} ${NM2} ${NM3} ${NM4}`
NETWORK=
BROADCAST=`get_ip_addr ${BD1} ${BD2} ${BD3} ${BD4}`
DNS1=`get_ip_addr ${DNS1_1} ${DNS1_2} ${DNS1_3} ${DNS1_4}`
DNS2=`get_ip_addr ${DNS2_1} ${DNS2_2} ${DNS2_3} ${DNS2_4}`

EOF

ERR=$?

# Rsultat
if [ $ERR != 0 ]; then
	echo "<BODY><H1>Erreur criture config rseau !</H1></BODY>"
	exit 1
fi

echo "<BODY><H1>Configuration enregistre !</H1></BODY>"

else
	echo "<BODY><H1>Erreur de configuration !</H1></BODY>"
	exit 0
fi
