#!/bin/sh

echo MIME-Version: 1.0
echo Content-type: text/html
echo 

. /etc/sysconfig/variables

TMPFILE=/tmp/vmstat$$
LASTFILE=/tmp/vmstat_last$$

get_version_info ()
{
	X=`cat /proc/version`
	set $X
	echo $1 $2 $3
}

get_uptime_info ()
{
	X=`cat /proc/uptime`
	set $X
	echo $1
}

get_proc_info ()
{
	X=`cat /proc/cpuinfo | grep cpu`
	set $X
	CPU=$3
	X=`cat /proc/cpuinfo | grep model`
	set $X
	shift; shift
	echo $CPU $*
}

get_mem_info ()
{
	X=`cat /proc/meminfo | grep $1`
	set $X
	echo $2
}

get_fs_info_fs ()
{
	X=`df -k | grep -v Filesystem`
	set $X
	echo $1	
}

get_fs_info_total ()
{
	X=`df -k | grep -v Filesystem`
	set $X
	echo $2
}

get_fs_info_used ()
{
	X=`df -k | grep -v Filesystem`
	set $X
	echo $3
}

get_fs_info_free ()
{
	X=`df -k | grep -v Filesystem`
	set $X
	echo $4
}

get_fs_info_cap ()
{
	X=`df -k | grep -v Filesystem`
	set $X
	echo $5
}

get_fs_info_mount ()
{
	X=`df -k | grep -v Filesystem`
	set $X
	echo $6
}

get_proc_nb ()
{
	X=`cat /proc/loadavg`
	set $X
	Y=`echo $4 | sed -e "s,/, ,g"`
	set $Y
	echo $2
}

get_user_time ()
{
	echo 100
}

get_time_info ()
{
    cat $TMPFILE | while read c
    do
	echo $c > $LASTFILE
    done

    X=`cat $LASTFILE`
    set $X
    shift; shift; shift; shift
    shift; shift; shift; shift
    shift; shift; shift; shift; shift
    echo $1 $2 $3
}


# Init statistiques systeme
vmstat > $TMPFILE
X=`get_time_info`
set $X
USER_T_M=$1
SYS_T_M=$2
IDLE_T_M=$3

vmstat 1 > $TMPFILE &
VMPID=$!
sleep 2
kill $VMPID

X=`get_time_info`
set $X
USER_T=$1
SYS_T=$2
IDLE_T=$3

rm -f $TMPFILE $LASTFILE

# Affichage HTML

cat << EOF

<BODY>
<CENTER>
<H1>Statistiques du systme</H1>

<HR>
<P>

<TABLE>
<TR>
<TD ><STRONG>Systme: </STRONG></TD>
<TD>`get_version_info`</TD>
</TR>
</TABLE>
<P>

<TABLE>
<TR>
<TD ><STRONG>Dure actuelle de fonctionnement: </STRONG></TD>
<TD>`get_uptime_info` secondes</TD>
</TR>
</TABLE>
<P>


<TABLE>
<TR>
<TD ><STRONG>Type de processeur: </STRONG></TD>
<TD>`get_proc_info`</TD>
</TR>
</TABLE>
<P>

<STRONG>Occupation mmoire (Kbytes)</STRONG>
<P>
<TABLE BORDER=1>
<TR ALIGN=center>
<TD WIDTH=100>Totale</TD>
<TD WIDTH=100>Libre</TD>
<TD WIDTH=100>Partage</TD>
<TD WIDTH=100>Buffers</TD>
<TD WIDTH=100>Cache</TD>
</TR>

<TR ALIGN=center>
<TD WIDTH=100>`get_mem_info MemTotal`</TD>
<TD WIDTH=100>`get_mem_info MemFree`</TD>
<TD WIDTH=100>`get_mem_info MemShared`</TD>
<TD WIDTH=100>`get_mem_info Buffers`</TD>
<TD WIDTH=100>`get_mem_info Cached`</TD>
</TR>

</TABLE>
<P>

<STRONG>Occupation disque (Mbytes)</STRONG>
<P>

<P>
<TABLE BORDER=1>

<TR ALIGN=center>
<TD WIDTH=100>Disque</TD>
<TD WIDTH=100>Total</TD>
<TD WIDTH=100>Utilis</TD>
<TD WIDTH=100>Libre</TD>
<TD WIDTH=100>Capacit</TD>
<TD WIDTH=100>Mont sur</TD>
</TR>

<TR ALIGN=center>
<TD WIDTH=100>`get_fs_info_fs`</TD>
<TD WIDTH=100>`get_fs_info_total`</TD>
<TD WIDTH=100>`get_fs_info_used`</TD>
<TD WIDTH=100>`get_fs_info_free`</TD>
<TD WIDTH=100>`get_fs_info_cap`</TD>
<TD WIDTH=100>`get_fs_info_mount`</TD>
</TR>

</TABLE>
<P>

<STRONG>Activit</STRONG>
<P>

<TABLE BORDER=1>

<TR ALIGN=center>
<TD WIDTH=100>Processus</TD>
<TD WIDTH=140>Temps utilisateur %</TD>
<TD WIDTH=140>Temps systme %</TD>
<TD WIDTH=140>Temps libre %</TD>
</TR>

<TR ALIGN=center>
<TD WIDTH=100>`get_proc_nb`</TD>
<TD WIDTH=140>${USER_T}/${USER_T_M}</TD>
<TD WIDTH=140>${SYS_T}/${SYS_T_M}</TD>
<TD WIDTH=140>${IDLE_T}/${IDLE_T_M}</TD>
</TR>

</TABLE>

</CENTER>
</BODY>

EOF
