#!/bin/sh
#
# /etc/rc.d/rc.S:  System initialization script.
#
#set -x
. /etc/sysconfig/variables

PATH=/sbin:/bin

. $BASE/$GENCFG
. $BASE/$NETCFG
		
# Start update.
/sbin/update &

# Check the integrity of all filesystems
#/sbin/fsck -A -a -T 1>/dev/null

# Remount the root filesystem in read-write mode
#echo "Remounting root device with read-write enabled."
/bin/mount -w -n -o remount /
if [ $? -gt 0 ]; then
  echo
  echo "Attempt to remount root device as read-write failed !"
  echo "This is going to cause serious problems..."
fi

# Nettoyage des locks et autres pid files
# remove /etc/mtab* so that mount will create it with a root entry
/bin/rm -f /etc/mtab* /etc/nologin /var/adm/utmp
/bin/rm -f /var/run/*.pid
/bin/rm -f /var/run/utmp
/bin/rm -f /var/lock/LCK..*
/bin/rm -f /usr/local/viewcom/grabber/run/*.pid
/bin/rm -f /usr/local/viewcom/grabber/run/*.control
/bin/rm -f /usr/local/viewcom/grabber/run/*.stop_grab

# mount file systems in fstab (and create an entry for /)
# but not NFS because TCP/IP is not yet configured
/bin/mount -at nonfs

# Looks like we have to create this.
cat /dev/null > /var/run/utmp

# Configure the system clock.
/sbin/clock -s

# Kbd
/bin/loadkeys "/usr/lib/kbd/keytables/$KEYTABLE" 1>/dev/null 2>&1

# Clean tmp files
/bin/rm -rf /tmp/* /var/lock/LCK..*

# Network
/etc/rc.d/rc.inet1 start
/etc/rc.d/rc.inet2 start

# Shell
PATH=/extra/bin:$PATH
HOME=/root
USER=root
#export PATH HOME USER
cd $HOME
/bin/bash 

# Reboot ...
#/sbin/shutdown -rf now
