#include <rtl.h>
#include <time.h>
#include <pthread.h>
#include <rtl_fifo.h>

pthread_t thread;
char c;

int my_fifo_handler (unsigned int fifo)
{
  int err;

  while ((err = rtf_get (0, &c, 1)) == 1) {
    rtl_printf("my_fifo_handler: got %x %c\n", c, c);
    pthread_wakeup_np (thread);
  }

  if (err != 0)
	   return -EINVAL;
  else
    return 0;
}

void * start_routine(void *arg)
{
	struct sched_param p;
	p . sched_priority = 1;
	pthread_setschedparam (pthread_self(), SCHED_FIFO, &p);

	while (1) {
		pthread_wait_np ();
		rtl_printf("start_routine: Got char %x\n", c);
	}
	return 0;
}

int init_module(void) {
  int f;

  rtf_destroy (0);
  f = rtf_create (0, 100);
  rtf_create_handler(0, &my_fifo_handler); 
  
  return pthread_create (&thread, NULL, start_routine, 0);
}

void cleanup_module(void) {
  rtf_destroy(0);
  pthread_delete_np (thread);
}
