#!/bin/sh

if [ $# -lt 2 ]
then
	echo "Usage: hist-to-jpg.sh title filename1.hist [filename2.hist] ..."
fi

TITLE=$1
INFILE=$2
OUTFILE=$TITLE.png
# $(echo $INFILE | sed -e 's/.hist$/.png/')
shift
#
# Remove all samples less than 1 usec
#
cat > .tmp_hist <<EOF
set term png
set title "$TITLE"
set output "$OUTFILE"
set xlabel "microseconds"
set ylabel "occurrences"
set logscale x
set logscale y
set xrange [.1 to *]
set yrange [.1 to *]

plot \\
EOF

i=1

sed -e 's/^0*\ /.1\ /' < $1 > .tmp_$1
echo \".tmp_$1\" with lines \\ >> .tmp_hist
shift

while [ $# -gt 0 ]; do
    sed -e 's/^0*\ /.1\ /' < $1 > .tmp_$1
    echo ,\".tmp_$1\" with lines \\ >> .tmp_hist
    shift
done

gnuplot < .tmp_hist

rm .tmp_*

