/*
 * Project: rtai_cpp - RTAI C++ Framework 
 *
 * File: $Id: cond.h,v 1.1 2002/03/30 17:24:38 erwin Exp $
 *
 * Copyright: (C) 2001,2002 Erwin Rol <erwin@muffin.org>
 *
 * Licence:
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 */

#include "rtai_wrapper.h"
#include "count.h"
#include "sem.h"
#include "mutex.h"

#ifndef __COND_H__
#define __COND_H__

namespace RTAI {

class Condition
:	public Semaphore 
{
public:
	Condition();
	~Condition();
	int wait( Mutex& mtx );
        int wait_until( Mutex& mtx, const Count& time);
	int wait_timed( Mutex& mtx, const Count& delay); 	
private:
	Condition(const Condition&);
	Condition& operator=(const Condition&);
};

}; // namespace RTAI

#endif
